
/**************************************************************************
     ISAREG.C
     C-Modul zur Ansteuerung der
     Register des CAN-Controllers 82C200 auf der PEAK-ISA-CAN-Karte bzw.
     PCAN-PC-104 Karte.
	
     Allgemeines zum CAN-Controller:
     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     Der CAN-Controller 82C200 besitzt 32 interne Register.
     Diese sind 0..31 nummeriert.
     Die 32 Register erscheinen an 32 aufeinanderfolgenden Adressen
     im IO-Adressbereich des PC's.
     Ein Schreiben nach Register 31 lst einen Hardwarereset
     des 82C200 aus (falls der entsprechende Jumper gesetzt ist).


     Copyright (C) 1996 by PEAK Service GmbH, Darmstadt.
     ************************************************************/


/* Prototypen der definierte Routinen:
   Uebergabeparameter:
  'basisadr': Adresse der ISA-Karte (z.B. '0x300' fr die Defaultadresse).
  'reg_adr':  anzusprechendes Register im 82C200
              (z.B. '2' fr das Statusregister).
  'reg_val':  in ein Register zu schreibender Wert.
*/

/* Prototypen fue Schreib/Leseroutinen */
unsigned char isa_regread(int basisadr, unsigned char reg_adr) ;
void isa_regwrite(int basisadr, unsigned char reg_adr, unsigned char reg_val) ;


/* Definitionen fuer byteweisen IO-Zugriff */
#include <conio.h>
#define _outp outp
#define _inp inp


unsigned char isa_regread(int basisadr, unsigned char reg_adr)
{
	return _inp(basisadr + reg_adr) ;
}

void isa_regwrite(int basisadr, unsigned char reg_adr, unsigned char reg_val)
{
	_outp(basisadr + reg_adr, reg_val) ;
}
