//---------------------------------------------------------------------------
// Demosoftware for PCAN-Light Driver
// PCAN_DNG.DLL
// Version: 1.030
// Autor: U.Wilhelm
// BETA Stand 25.08.2000
//---------------------------------------------------------------------------


#include <vcl.h>
#pragma hdrstop

#include "PCANLight_Demo.h"
#include <stdio.h>

//Header der Dongel DLL
#include "PCAN_DNG.h"

#define IOPORT  0x378
#define INTER 7


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{

}
//---------------------------------------------------------------------------
void __fastcall TForm1::CAN_InitBClick(TObject *Sender)
{
 DWORD ret;
 // Initialisiere PCAN-Dongle im MUX mode auf Port 0x378 und Interruot 7
 ret=CAN_Init(CAN_BAUD_500K, CAN_INIT_TYPE_ST, HW_DONGLE_SJA, IOPORT, INTER);
 Label2->Caption=ret;
 Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CAN_CloseBClick(TObject *Sender)
{
 DWORD ret;
 // Timer aus
 Timer1->Enabled=false;
 // von Treiber abmelden !!
 ret=CAN_Close();
 Label6->Caption=ret;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CAN_StatusBClick(TObject *Sender)
{
 DWORD ret;
 // Hole Status
 ret=CAN_Status();
 Label3->Caption=ret;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CAN_WriteBClick(TObject *Sender)
{
 DWORD ret;
 TPCANMsg myMsg;

 // Fuelle Datenstruktur
 myMsg.ID=0x100;
 myMsg.MSGTYPE=0x00;//Std. Frame
 myMsg.LEN=8;
 myMsg.DATA[0]=1;
 myMsg.DATA[1]=2;
 myMsg.DATA[2]=4;
 myMsg.DATA[3]=8;
 myMsg.DATA[4]=16;
 myMsg.DATA[5]=32;
 myMsg.DATA[6]=64;
 myMsg.DATA[7]=128;
 // und senden....
 ret=CAN_Write(&myMsg);
 // wenn ret =0 --> CAN_ERR_OK dann hat das geklappt
 Label5->Caption=ret;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VersionInfoBClick(TObject *Sender)
{
 DWORD ret;
 char Version[255];
 ret=CAN_VersionInfo(Version);
 if(ret==CAN_ERR_OK)
   Label1->Caption=Version;
 else
   Label1->Caption="no driver found";
}
//---------------------------------------------------------------------------


void __fastcall TForm1::CAN_ReadBClick(TObject *Sender)
{
 TPCANMsg readMsg;
 DWORD ret;
 ret=CAN_Read(&readMsg);
 Label4->Caption=ret;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  TPCANMsg readMsg;
  char buffer[100];
  char buffer2[10];
  // Alle CAN Daten auslesen
  while ((CAN_Read(&readMsg) & CAN_ERR_QRCVEMPTY)==0 )//SOlange bis Buffer leer
  {
   if(Memo1->Lines->Count>500)
      Memo1->Clear();
   sprintf(buffer,"ID:%d LEN:%d ",readMsg.ID,readMsg.LEN);
   for(int i=0;i<readMsg.LEN;i++)
   {
    sprintf(buffer2,"0x%02x ",readMsg.DATA[i]);
    strcat(buffer,buffer2);
   }
   Memo1->Lines->Add(buffer);

  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  //Teste den Treiber
 DWORD ret;
 char txtbuff[200];
 TPCANMsg myMsg;
 TPCANMsg readMsg;

 // Initialisiere PCAN-Dongle im MUX mode auf Port 0x378 und Interruot 7
 ret=CAN_Init(CAN_BAUD_500K, CAN_INIT_TYPE_ST, HW_DONGLE_SJA, IOPORT, INTER);
 Label2->Caption=ret;
 if(ret!=CAN_ERR_OK)
 {
  check_err(ret,txtbuff);
  Memo1->Lines->Add(txtbuff);
  Application->MessageBox(txtbuff,"error info - CAN_Init",MB_ICONINFORMATION);
  return;
 }
 ret=CAN_Status();
 Label3->Caption=ret;
 if(ret!=CAN_ERR_OK)
 {
  check_err(ret,txtbuff);
  Memo1->Lines->Add(txtbuff);
  Application->MessageBox(txtbuff,"error info - CAN_Status",MB_ICONINFORMATION);
  return;
 }

 // Fuelle Datenstruktur
 myMsg.ID=0x0FF;
 myMsg.MSGTYPE=0x00;//Std. Frame
 myMsg.LEN=8;
 myMsg.DATA[0]=128;
 myMsg.DATA[1]=64;
 myMsg.DATA[2]=32;
 myMsg.DATA[3]=16;
 myMsg.DATA[4]=8;
 myMsg.DATA[5]=4;
 myMsg.DATA[6]=2;
 myMsg.DATA[7]=1;
 // und senden....
 ret=CAN_Write(&myMsg);
 // wenn ret =0 --> CAN_ERR_OK dann hat das geklappt
 Label5->Caption=ret;
 if(ret!=CAN_ERR_OK)
 {
  check_err(ret,txtbuff);
  Memo1->Lines->Add(txtbuff);
  Application->MessageBox(txtbuff,"error info - CAN_Write",MB_ICONINFORMATION);
  return;
 }
 ret=CAN_Read(&readMsg);
 Label4->Caption=ret;
 if(ret!=CAN_ERR_OK)
 {
  check_err(ret,txtbuff);
  Memo1->Lines->Add(txtbuff);
  Application->MessageBox(txtbuff,"error info - CAN_Read",MB_ICONINFORMATION);
  return;
 }
 ret=CAN_Close();
 Label6->Caption=ret;
 if(ret!=CAN_ERR_OK)
 {
  check_err(ret,txtbuff);
  Memo1->Lines->Add(txtbuff);
  Application->MessageBox(txtbuff,"error info - CAN_Close",MB_ICONINFORMATION);
  return;
 }
}

//---------------------------------------------------------------------------
void check_err(DWORD err,  char *txtbuff)
{
#define CAN_ERR_HWINUSE   0x0400  // Hardware ist von Netz belegt
#define CAN_ERR_NETINUSE  0x0800  // an Netz ist Client angeschlossen
#define CAN_ERR_ILLHW     0x1400  // Hardwarehandle war ungueltig
#define CAN_ERR_ILLNET    0x1800  // Netzhandle war ungueltig
#define CAN_ERR_ILLCLIENT 0x1C00  // Clienthandle war ungueltig

        strcpy(txtbuff, "Error: ") ;
        if ( err == CAN_ERR_OK )        strcpy(txtbuff, "OK ") ;
        if ( err & CAN_ERR_XMTFULL )    strcat(txtbuff, "XMTFULL ") ;
        if ( err & CAN_ERR_OVERRUN )    strcat(txtbuff, "OVERRUN ") ;
        if ( err & CAN_ERR_BUSLIGHT )   strcat(txtbuff, "BUSLIGHT ") ;
        if ( err & CAN_ERR_BUSHEAVY )   strcat(txtbuff, "BUSHEAVY ") ;
        if ( err & CAN_ERR_BUSOFF )     strcat(txtbuff, "BUSOFF ") ;
        if ( err & CAN_ERR_QRCVEMPTY )  strcat(txtbuff, "QRCVEMPTY ") ;
        if ( err & CAN_ERR_QOVERRUN )   strcat(txtbuff, "QOVERRUN ") ;
        if ( err & CAN_ERR_QXMTFULL )   strcat(txtbuff, "QXMTFULL ") ;
        if ( err & CAN_ERR_REGTEST )    strcat(txtbuff, "REGTEST ") ;
        if ( err & CAN_ERR_NOVXD )      strcat(txtbuff, "NOVXD ") ;
        if ( (err & CAN_ERRMASK_ILLHANDLE) == CAN_ERR_HWINUSE ) strcat(txtbuff, "HWINUSE ") ;
        if ( (err & CAN_ERRMASK_ILLHANDLE) == CAN_ERR_NETINUSE ) strcat(txtbuff, "NETINUSE ") ;
        if ( (err & CAN_ERRMASK_ILLHANDLE) == CAN_ERR_ILLHW )strcat(txtbuff, "ILLHW ") ;
        if ( (err & CAN_ERRMASK_ILLHANDLE) == CAN_ERR_ILLCLIENT )strcat(txtbuff, "ILLCLIENT ") ;
        if ( (err & CAN_ERRMASK_ILLHANDLE) == CAN_ERR_ILLNET ) strcat(txtbuff, "ILLNET ") ;
        if ( err & CAN_ERR_RESOURCE ) strcat(txtbuff, "RESOURCE ") ;
        if ( err & CAN_ERR_ILLPARAMTYPE ) strcat(txtbuff, "ILLPARAMTYPE ") ;
        if ( err & CAN_ERR_ILLPARAMVAL ) strcat(txtbuff, "ILLPARAMVAL ") ;
        return;
 }


