// PCAN-Light Q and D Delphi Example
// (c) PEAK-System Technik Gmbj
// U. Wilhelm

unit Light_Sample;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,pcan_dng, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    Label2: TLabel;
    Button3: TButton;
    Label3: TLabel;
    Timer1: TTimer;
    Button4: TButton;
    Label4: TLabel;
    Label5: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  counter: Dword;
implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
 ret: LongWord;
 str: String;

begin

 ret:=CAN_Init(CAN_BAUD_500K, CAN_INIT_TYPE_ST, HW_DONGLE_SJA,$378, $7);
 str := Format('retwert: %d ',[ret]);
 Label1.Caption:= str;

end;

procedure TForm1.Button2Click(Sender: TObject);
var
 ret: LongWord;
 str: String;

begin
 ret:=CAN_Close();
 str := Format('retwert: %d ',[ret]);
 Label2.Caption:= str;



end;

procedure TForm1.Button3Click(Sender: TObject);
var
 ret: LongWord;
 str: String;
 MsgBuff: TPCANMsg;

begin
 MsgBuff.ID:=$100;
 MsgBuff.MSGTYPE:=0;
 MsgBuff.LEN:=8;
 MsgBuff.DATA[0]:=1;
 MsgBuff.DATA[1]:=2;
 MsgBuff.DATA[2]:=3;
 MsgBuff.DATA[3]:=4;
 MsgBuff.DATA[4]:=5;
 MsgBuff.DATA[5]:=6;
 MsgBuff.DATA[6]:=7;
 MsgBuff.DATA[7]:=8;
 ret:=CAN_Write(MsgBuff);
 str := Format('retwert: %d ',[ret]);
 Label3.Caption:= str;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
var	msg: TPCANMsg;
	str: String;
	i: Integer;
        ret: Word;
begin
 while ((CAN_Read(msg) and CAN_ERR_QRCVEMPTY) = 0) do
  begin
        counter:=counter+1;
  	// Eine Message war in der Queue
	if ((msg.MSGTYPE and MSGTYPE_EXTENDED) <> 0) then
	  str := Format('%.8x  %d ', [msg.ID, msg.LEN])	// Extended Frame
	else
	  str := Format('%.4x  %d ', [msg.ID, msg.LEN]);

	if ((msg.MSGTYPE and MSGTYPE_RTR) = 0) then
	begin
	  // Data Frame
	  for i := 0 to msg.LEN-1 do
		str := str + Format(' %.2x', [msg.DATA[i]]);
	end
	else
	  str := str + ' Remote Request';	// Remote Frame

	Label4.Caption:=str;
        str := Format('Msgs rec.: %d', [counter]);
        Label5.Caption:=str;
   end;
  end;


procedure TForm1.Button4Click(Sender: TObject);

var
 ret: LongWord;
 str: String;
 MsgBuff: TPCANMsg;

begin
 ret:=CAN_Read(MsgBuff);
 str := Format('retwert: %d ',[ret]);
 Label4.Caption:= str;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 counter:=0;
end;

end.
